<!-- Copyright (c) 2017 Louisiana State University                                  -->
<!-- Copyright (c) 2017 Oregon University                                           -->
<!--                                                                                -->
<!--   Distributed under the Boost Software License, Version 1.0. (See accompanying -->
<!--   file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)        -->

# Phylanx: An Asynchronous Distributed Array Computing Toolkit

Find our project website [here](http://phylanx.stellar-group.org/). This site provides an overview of the project as well 
as information on who we are and what we plan to do! 

The full documentation for the project can be found [here](https://stellar-group.github.io/phylanx/). If you can't find what you are looking for in the documentation or you suspect you've found a bug in Phylanx we very much encourage and appreciate any issue reports through the [issue tracker for this Github project](https://github.com/STEllAR-GROUP/phylanx/issues).

The [CircleCI](https://circleci.com/gh/STEllAR-GROUP/phylanx) contiguous
integration service tracks the current build status for the master branch:
[![CircleCI](https://circleci.com/gh/STEllAR-GROUP/phylanx.svg?style=svg)](https://circleci.com/gh/STEllAR-GROUP/phylanx).


The [Buildbot](http://omega.nic.uoregon.edu:8020/tgrid) continuous integration
service tracks the current build status on several platforms and compilers:
[![x86_64 release build status](http://omega.nic.uoregon.edu:8020/badges/x86_64-gcc7-release.svg?left_text=x86_64-gcc7-release)](http://omega.nic.uoregon.edu:8020/#/)
[![KNL release build status](http://omega.nic.uoregon.edu:8020/badges/knl-gcc7-release.svg?left_text=KNL-gcc7-release)](http://omega.nic.uoregon.edu:8020/#/)
[![POWER8 release build status](http://omega.nic.uoregon.edu:8020/badges/ppc64le-clang5-release.svg?left_text=POWER8-clang5-release)](http://omega.nic.uoregon.edu:8020/#/)

[![x86_64 release build status](http://omega.nic.uoregon.edu:8020/badges/x86_64-gcc7-relwithdebinfo.svg?left_text=x86_64-gcc7-relwithdebinfo)](http://omega.nic.uoregon.edu:8020/#/)
[![KNL release build status](http://omega.nic.uoregon.edu:8020/badges/knl-gcc7-relwithdebinfo.svg?left_text=KNL-gcc7-relwithdebinfo)](http://omega.nic.uoregon.edu:8020/#/)
[![POWER8 release build status](http://omega.nic.uoregon.edu:8020/badges/ppc64le-clang5-relwithdebinfo.svg?left_text=POWER8-clang5-relwithdebinfo)](http://omega.nic.uoregon.edu:8020/#/)

[![x86_64 debug build status](http://omega.nic.uoregon.edu:8020/badges/x86_64-gcc7-debug.svg?left_text=x86_64-gcc7-debug)](http://omega.nic.uoregon.edu:8020/#/)
[![KNL debug build status](http://omega.nic.uoregon.edu:8020/badges/knl-gcc7-debug.svg?left_text=KNL-gcc7-debug)](http://omega.nic.uoregon.edu:8020/#/)
[![POWER8 debug build status](http://omega.nic.uoregon.edu:8020/badges/ppc64le-clang5-debug.svg?left_text=POWER8-clang5-debug)](http://omega.nic.uoregon.edu:8020/#/)

### Acknowledgements

We would like to acknowledge the NSF, DoD, the Center for Computation
and Technology (CCT) at Louisiana State University (LSU), and Oregon University
(OU) who fund and support our work.

We would also like to thank the following organizations for granting us
allocations of their compute resources: LSU HPC and OU.

Phylanx is currently funded by

* The National Science Foundation through awards 1737785 (Phylanx).

  Any opinions, findings, and conclusions or recommendations expressed in this
  material are those of the author(s) and do not necessarily reflect the views
  of the National Science Foundation.

* The Defense Technical Information Center under the contract: FA8075-14-D-0002/0007
